chiark / gitweb /
rsync-backup.in, rsync-backup.8: Trim caches on fshash mismatch.
[rsync-backup] / rsync-backup.in
1 #! @BASH@
2 ###
3 ### Backup script
4 ###
5 ### (c) 2012 Mark Wooding
6 ###
7
8 ###----- Licensing notice ---------------------------------------------------
9 ###
10 ### This file is part of the `rsync-backup' program.
11 ###
12 ### rsync-backup is free software; you can redistribute it and/or modify
13 ### it under the terms of the GNU General Public License as published by
14 ### the Free Software Foundation; either version 2 of the License, or
15 ### (at your option) any later version.
16 ###
17 ### rsync-backup is distributed in the hope that it will be useful,
18 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
19 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 ### GNU General Public License for more details.
21 ###
22 ### You should have received a copy of the GNU General Public License
23 ### along with rsync-backup; if not, write to the Free Software Foundation,
24 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
25
26 set -e
27
28 thishost=$(hostname -s)
29 quis=${0##*/}
30 . @pkgdatadir@/lib.sh
31
32 verbose=:
33 dryrun=nil
34
35 ###--------------------------------------------------------------------------
36 ### Utility functions.
37
38 RSYNCOPTS="--verbose"
39
40 do_rsync () {
41   ## Run rsync(1) in an appropriate manner.  Configuration should ovrride
42   ## this or set $RSYNCOPTS if it wants to do something weirder.  Arguments
43   ## to this function are passed on to rsync.
44
45   rsync \
46         --archive --hard-links --numeric-ids --del \
47         --sparse --compress \
48         --one-file-system \
49         --partial \
50         $RSYNCOPTS \
51         --filter="dir-merge .rsync-backup" \
52         "$@"
53 }
54
55 log () {
56   case $dryrun in
57     t)
58       echo >&2 "                *** $*"
59       ;;
60     nil)
61       now=$(date +"%Y-%m-%d %H:%M:%S %z")
62       echo >&9 "$now $*"
63       ;;
64   esac
65 }
66
67 maybe () {
68   ## Run CMD, if this isn't a dry run.
69
70   case $dryrun in
71     t) echo >&2 "               +++ $*" ;;
72     nil) "$@" ;;
73   esac
74 }
75
76 copy () {
77   prefix=$1
78   ## Copy lines from stdin to stdout, adding PREFIX.
79
80   while IFS= read -r line; do
81     printf "%s %s\n" "$prefix" "$line"
82   done
83 }
84
85 run () {
86   stdinp=nil
87   while :; do
88     case $1 in
89       -stdin) stdinp=t; shift ;;
90       --) shift; break ;;
91       *) break ;;
92     esac
93   done
94   tag=$1 cmd=$2; shift 2
95   ## Run CMD, logging its output in a pleasing manner.
96
97   case $dryrun in
98     t)
99       echo >&2 "                *** RUN $tag"
100       echo >&2 "                +++ $cmd $*"
101       rc=0
102       ;;
103     nil)
104       log "BEGIN $tag"
105       rc=$(
106         case $stdinp in nil) exec </dev/null ;; esac
107         { { { ( set +e
108                 "$cmd" "$@" 3>&- 4>&- 5>&- 9>&-
109                 echo $? >&5; ) |
110               copy "|" >&4; } 2>&1 |
111             copy "*" >&4; } 4>&1 |
112           cat >&9; } 5>&1
113       )
114       case $rc in
115         0) log "END $tag" ;;
116         *) log "FAIL $tag (rc = $rc)" ;;
117       esac
118       ;;
119   esac
120   return $rc
121 }
122
123 run_diff () {
124   out=$1 old=$2 new=$3
125   ## Write a unified diff from OLD to NEW, to OUT.
126
127   set +e; diff -u "$old" "$new" >"$out"; rc=$?; set -e
128   case $rc in 1) cat "$out" ;; esac
129   return $rc
130 }
131
132 localp () {
133   h=$1
134   ## Answer whether H is a local host.
135
136   case $h in
137     "$thishost") return 0 ;;
138     *) return 1 ;;
139   esac
140 }
141
142 hostrun () {
143   tag=$1 cmd=$2
144   ## Run CMD on the current host.  If the host seems local then run the
145   ## command through a local shell; otherwise run it through ssh(1).  Either
146   ## way it will be processed by a shell.
147
148   if localp $host; then run "@$host: $tag" sh -c "$cmd"
149   else run "@$host: $tag" ssh $userat$host "$cmd"
150   fi
151 }
152
153 _hostrun () {
154   h=$1 cmd=$2
155   ## Like hostrun, but without the complicated logging, and targetted at a
156   ## specific host.
157
158   if localp $h; then sh -c "$cmd"
159   else ssh $h "$cmd"
160   fi
161 }
162
163 hostpath () {
164   path=$1
165   ## Output (to stdout) either PATH or HOST:PATH, choosing the former if the
166   ## current host is local.
167
168   if localp $host; then echo $path
169   else echo $userat$host:$path
170   fi
171 }
172
173 defhook () {
174   hook=$1
175   ## Define a hook called HOOK.
176
177   eval hk_$hook=
178 }
179
180 addhook () {
181   hook=$1 cmd=$2
182   ## Add command CMD to the hook HOOK.
183
184   eval old=\$hk_$hook; new="$old $cmd"
185   eval hk_$hook=\$new
186 }
187
188 runhook () {
189   hook=$1; shift 1
190   ## Invoke HOOK, passing it the remaining arguments.
191
192   eval cmds=\$hk_$hook
193   for cmd in $cmds; do
194     if ! $cmd "$@"; then return $?; fi
195   done
196 }
197
198 remove_old_logfiles () {
199   base=$1
200   ## Remove old logfiles with names of the form BASE.DATE#N, so that there
201   ## are at most $MAXLOG of them.
202
203   ## Count up the logfiles.
204   nlog=0
205   for i in "$base".*; do
206     if [ ! -f "$i" ]; then continue; fi
207     nlog=$(( nlog + 1 ))
208   done
209
210   ## If there are too many, go through and delete some early ones.
211   if [ $dryrun = nil ] && [ $nlog -gt $MAXLOG ]; then
212     n=$(( nlog - MAXLOG ))
213     for i in "$base".*; do
214       if [ ! -f "$i" ]; then continue; fi
215       rm -f "$i"
216       n=$(( n - 1 ))
217       if [ $n -eq 0 ]; then break; fi
218     done
219   fi
220 }
221
222 ###--------------------------------------------------------------------------
223 ### Database operations.
224
225 insert_index () {
226   host=$1 fs=$2 date=$3 vol=$4
227
228   if [ -f "$INDEXDB" ]; then
229     sqlite3 "$INDEXDB" <<EOF
230 INSERT INTO idx (host, fs, date, vol)
231         VALUES ('$host', '$fs', '$date', '$vol');
232 EOF
233   fi
234 }
235
236 delete_index () {
237   host=$1 fs=$2 date=$3
238
239   if [ -f "$INDEXDB" ]; then
240     sqlite3 "$INDEXDB" <<EOF
241 DELETE FROM idx WHERE
242         host = '$host' AND fs = '$fs' AND date = '$date';
243 EOF
244   fi
245 }
246
247 ###--------------------------------------------------------------------------
248 ### Snapshot handling.
249
250 ## Snapshot protocol.  Each snapshot type has a pair of functions snap_TYPE
251 ## and unsnap_TYPE.  Each is given the current snapshot arguments and the
252 ## filesystem name to back up.  The snap_TYPE function should create and
253 ## mount the snapshot and output an rsync(1) path to where the filesystem can
254 ## be copied; the unsnap_TYPE function should unmount and tear down the
255 ## snapshot.
256
257 ## Fake snapshot by not doing anything.  Use only if you have no choice.
258 snap_live () { hostpath "$2"; }
259 unsnap_live () { :; }
260
261 ## Fake snapshot by remounting a live filesystem read-only.  Useful if the
262 ## underlying storage isn't in LVM.
263
264 snap_ro () {
265   fs=$1 mnt=$2
266
267   ## Place a marker in the filesystem so we know why it was made readonly.
268   ## (Also this serves to ensure that the filesystem was writable before.)
269   hostrun "snap-ro $mnt" "
270         echo rsync-backup >$mnt/.lock
271         mount -oremount,ro $mnt" || return $?
272
273   ## Done.
274   hostpath $mnt
275 }
276
277 unsnap_ro () {
278   fs=$1 mnt=$2
279
280   ## Check that the filesystem still has our lock marker.
281   hostrun "unsnap-ro $mnt" "
282         case \$(cat $mnt/.lock) in
283           rsync-backup) ;;
284           *) echo unlocked by someone else; exit 31 ;;
285         esac
286         mount -oremount,rw $mnt
287         rm $mnt/.lock" || return $?
288 }
289
290 ## Snapshot using LVM.
291
292 SNAPSIZE="-l10%ORIGIN"
293
294 snap_lvm () {
295   vg=$1 lv=$2
296
297   ## Make the snapshot.
298   hostrun "snap-lvm $vg/$lv" "
299         lvcreate --snapshot -n$lv.bkp $SNAPSIZE $vg/$lv
300         mkdir -p $SNAPDIR/$lv
301         mount -oro /dev/$vg/$lv.bkp $SNAPDIR/$lv" || return $?
302
303   ## Done.
304   hostpath $SNAPDIR/$lv
305 }
306
307 unsnap_lvm () {
308   vg=$1 lv=$2
309
310   ## Remove the snapshot.  Sometimes LVM doesn't notice that the snapshot is
311   ## no longer in open immdiately, so try several times.
312   hostrun "unsnap-lvm $vg/$lv" "
313         umount $SNAPDIR/$lv
314         rc=1
315         for i in 1 2 3 4; do
316           if lvremove -f $vg/$lv.bkp; then rc=0; break; fi
317           sleep 2
318         done
319         exit $rc" || return $?
320 }
321
322 ## Complicated snapshot using LVM, where the volume group and filesystem are
323 ## owned by different machines, so they need to be synchronized during the
324 ## snapshot.
325
326 do_rfreezefs () {
327   lvhost=$1 vg=$2 lv=$3 fshost=$4 fsdir=$5
328
329   ## Engage in the rfreezefs protocol with the filesystem host.  This
330   ## involves some hairy plumbing.  We want to get exit statuses out of both
331   ## halves.
332   set +e
333   ssh $fshost rfreezefs $fsdir | {
334     set -e
335
336     ## Read the codebook from the remote end.
337     ready=nil
338     while read line; do
339       set -- $line
340       case "$1" in
341         PORT) port=$2 ;;
342         TOKEN) eval tok_$2=$3 ;;
343         READY) ready=t; break ;;
344         *)
345           echo >&2 "$quis: unexpected keyword $1 (rfreezefs to $rhost)"
346           exit 1
347           ;;
348       esac
349     done
350     case $ready in
351       nil)
352         echo >&2 "$quis: unexpected eof (rfreezefs to $rhost)"
353         exit 1
354         ;;
355     esac
356
357     ## Connect to the filesystem host's TCP port and get it to freeze its
358     ## filesystem.
359     exec 3<>/dev/tcp/$fshost/$port
360     echo $tok_FREEZE >&3
361     read tok <&3
362     case $tok in
363       "$tok_FROZEN") ;;
364       *)
365         echo >&2 "$quis: unexpected token $tok (rfreezefs $fsdir on $fshost)"
366         exit 1
367         ;;
368     esac
369
370     ## Get the volume host to create the snapshot.
371     set +e
372     _hostrun >&2 3>&- $userat$lvhost \
373       "lvcreate --snapshot -n$lv.bkp $SNAPSIZE $vg/$lv"
374     snaprc=$?
375     set -e
376
377     ## The filesystem can thaw now.
378     echo $tok_THAW >&3
379     read tok <&3
380     case $tok in
381       "$tok_THAWED") ;;
382       *)
383         _hostrun >&2 3>&- $userat$lvhost "lvremove -f $vg/$lv.bkp" || :
384         echo >&2 "$quis: unexpected token $tok (rfreezefs $fsdir on $fshost)"
385         exit 1
386         ;;
387     esac
388
389     ## Done.
390     exit $snaprc
391   }
392
393   ## Sift through the wreckage to find out what happened.
394   rc_rfreezefs=${PIPESTATUS[0]} rc_snapshot=${PIPESTATUS[1]}
395   set -e
396   case $rc_rfreezefs:$rc_snapshot in
397     0:0)
398       ;;
399     112:*)
400       echo >&2 "$quis: EMERGENCY failed to thaw $fsdir on $fshost!"
401       exit 112
402       ;;
403     *)
404       echo >&2 "$quis: failed to snapshot $vg/$lv ($fsdir on $fshost)"
405       exit 1
406       ;;
407   esac
408
409   ## Mount the snapshot on the volume host.
410   _hostrun >&2 $userat$lvhost "
411         mkdir -p $SNAPDIR/$lv
412         mount -oro /dev/$vg/$lv.bkp $SNAPDIR/$lv"
413 }
414
415 snap_rfreezefs () {
416   rhost=$1 vg=$2 lv=$3 rfs=$4
417
418   set -e
419   run "snap-rfreezefs $host:$vg/$lv $rhost:$rfs" \
420     do_rfreezefs $host $vg $lv $rhost $rfs || return $?
421   hostpath $SNAPDIR/$lv
422 }
423
424 unsnap_rfreezefs () {
425
426   ## Unshapping is the same as for plain LVM.
427   rhost=$1 vg=$2 lv=$3 rfs=$4
428   unsnap_lvm $vg $lv
429 }
430
431 ###--------------------------------------------------------------------------
432 ### Expiry computations.
433
434 expire () {
435   ## Read dates on stdin; write to stdout `EXPIRE date' for dates which
436   ## should be expired and `RETAIN date' for dates which should be retained.
437
438   ## Get the current date and convert it into useful forms.
439   now=$(date +%Y-%m-%d)
440   parsedate $now
441   now_jdn=$(julian $now) now_year=$year now_month=$month now_day=$day
442   kept=:
443
444   ## Work through each date in the input.
445   while read date; do
446     keep=nil
447
448     ## Convert the date into a useful form.
449     jdn=$(julian $date)
450     parsedate $date
451
452     ## Work through the policy list.
453     if [ $jdn -le $now_jdn ]; then
454       while read ival age; do
455
456         ## Decide whether the policy entry applies to this date.
457         apply=nil
458         case $age in
459           forever)
460             apply=t
461             ;;
462           year)
463             if [ $year -eq $now_year ] ||
464                ([ $year -eq $(( $now_year - 1 )) ] &&
465                 [ $month -ge $now_month ])
466             then apply=t; fi
467             ;;
468           month)
469             if ([ $month -eq $now_month ] && [ $year -eq $now_year ]) ||
470                ((([ $month -eq $(( $now_month - 1 )) ] &&
471                   [ $year -eq $now_year ]) ||
472                  ([ $month -eq 12 ] && [ $now_month -eq 1 ] &&
473                   [ $year -eq $(( $now_year - 1 )) ])) &&
474                 [ $day -ge $now_day ])
475             then apply=t; fi
476             ;;
477           week)
478             if [ $jdn -ge $(( $now_jdn - 7 )) ]; then apply=t; fi
479             ;;
480           *)
481             echo >&2 "$quis: unknown age symbol \`$age'"
482             exit 1
483             ;;
484         esac
485         case $apply in nil) continue ;; esac
486
487         ## Find the interval marker for this date.
488         case $ival in
489           daily)
490             marker=$date
491             ;;
492           weekly)
493             ydn=$(julian $year-01-01)
494             wk=$(( ($jdn - $ydn)/7 + 1 ))
495             marker=$year-w$wk
496             ;;
497           monthly)
498             marker=$year-$month
499             ;;
500           annually | yearly)
501             marker=$year
502             ;;
503           *)
504             echo >&2 "$quis: unknown interval symbol \`$ival'"
505             exit 1
506             ;;
507         esac
508
509         ## See if we've alredy retained something in this interval.
510         case $kept in
511           *:"$marker":*) ;;
512           *) keep=t kept=$kept$marker: ;;
513         esac
514
515       done <<EOF
516 $expire_policy
517 EOF
518     fi
519
520     case $keep in
521       t) echo RETAIN $date ;;
522       *) echo EXPIRE $date ;;
523     esac
524
525   done
526 }
527
528 ###--------------------------------------------------------------------------
529 ### Actually taking backups of filesystems.
530
531 MAXLOG=14
532 HASH=sha256
533 unset VOLUME
534
535 bkprc=0
536
537 remote_fshash () {
538   _hostrun $userat$host "
539         umask 077
540         mkdir -p $fshashdir
541         cd ${snapmnt#*:}
542         echo \"*** $host $fs $date\"; echo
543         rsync -rx --filter='dir-merge .rsync-backup' ./ |
544           fshash -c$fshashdir/$fs.bkp -a -H$HASH -frsync
545   " >new.fshash
546 }
547
548 local_fshash () {
549   { echo "*** $host $fs $date"; echo
550     fshash -c$STOREDIR/fshash.cache -H$HASH new/
551   } >$localmap
552 }
553
554 expire_backups () {
555   { seen=:
556     for i in *-*-*; do
557       i=${i%%.*}
558       case $i in *[!-0-9]*) continue ;; esac
559       case $seen in *:"$i":*) continue ;; esac
560       seen=$seen$i:
561       echo $i
562     done; } |
563   expire |
564   while read op date; do
565     case $op,$dryrun in
566       RETAIN,t)
567         echo >&2 "              --- keep   $date"
568         ;;
569       EXPIRE,t)
570         echo >&2 "              --- delete $date"
571         ;;
572       RETAIN,nil)
573         echo "keep   $date"
574         ;;
575       EXPIRE,nil)
576         echo "delete $date"
577         $verbose -n "   expire $date..."
578         rm -rf $date $date.*
579         delete_index $host $fs $date
580         $verbose " done"
581         ;;
582     esac
583   done
584 }
585
586 ## Backup hooks.
587 defhook setup
588 defhook precommit
589 defhook postcommit
590
591 backup_precommit_hook () {
592   host=$1 fs=$2 date=$3
593   ## Compatibility: You can override this hook in the configuration file for
594   ## special effects; but it's better to use `addhook precommit'.
595
596   :
597 }
598 addhook precommit backup_precommit_hook
599
600 backup_commit_hook () {
601   host=$1 fs=$2 date=$3
602   ## Compatibility: You can override this hook in the configuration file for
603   ## special effects; but it's better to use `addhook commit'.
604
605   :
606 }
607 addhook commit backup_commit_hook
608
609 do_backup () {
610   date=$1 fs=$2 fsarg=$3
611   ## Back up FS on the current host.
612
613   set -e
614   attempt=0
615   fshash_diff=nil
616
617   ## Run a hook beforehand.
618   set +e; runhook setup $host $fs $date; rc=$?; set -e
619   case $? in
620     0) ;;
621     99) log "BACKUP of $host:$fs SKIPPED by hook"; return 0 ;;
622     *) log "BACKUP of $host:$fs FAILED (hook returns $?)"; return $? ;;
623   esac
624
625   ## Report the start of this attempt.
626   log "START BACKUP of $host:$fs"
627
628   ## Maybe we need to retry the backup.
629   while :; do
630
631     ## Create and mount the remote snapshot.
632     case $dryrun in
633       t)
634         maybe snap_$snap $fs $fsarg
635         snapmnt="<snapshot>"
636         ;;
637       nil)
638         snapmnt=$(snap_$snap $snapargs $fs $fsarg) || return $?
639         ;;
640     esac
641     $verbose "  create snapshot"
642
643     ## If we had a fshash-mismatch, then clear out the potentially stale
644     ## entries, both locally and remotely.
645     case $fshash_diff in
646       nil) ;;
647       *)
648         $verbose "      prune cache"
649         run -stdin "local prune fshash" \
650           fshash -u -c$STOREDIR/fshash.cache -H$HASH new/ <$fshash_diff
651         run -stdin "@$host: prune fshash" \
652           _hostrun $userat$host <$fshash_diff \
653           "fshash -u -c$fshashdir/$fs.bkp -H$HASH ${snapmnt#*:}"
654         ;;
655     esac
656
657     ## Build the list of hardlink sources.
658     linkdests=""
659     for i in $host $like; do
660       d=$STOREDIR/$i/$fs/last/
661       if [ -d $d ]; then linkdests="$linkdests --link-dest=$d"; fi
662     done
663
664     ## Copy files from the remote snapshot.
665     maybe mkdir -p new/
666     case $dryrun in
667       t) $verbose "     running rsync" ;;
668       nil) $verbose -n "        running rsync..." ;;
669     esac
670     set +e
671     run "RSYNC of $host:$fs (snapshot on $snapmnt)" do_rsync \
672       $linkdests \
673       $rsyncargs \
674       $snapmnt/ new/
675     rc_rsync=$?
676     set -e
677     case $dryrun in nil) $verbose " done" ;; esac
678
679     ## Collect a map of the snapshot for verification purposes.
680     set +e
681     case $dryrun in
682       t) $verbose "     remote fshash" ;;
683       nil) $verbose -n "        remote fshash..." ;;
684     esac
685     run "@$host: fshash $fs" remote_fshash
686     rc_fshash=$?
687     set -e
688     case $dryrun in nil) $verbose " done" ;; esac
689
690     ## Remove the snapshot.
691     maybe unsnap_$snap $snapargs $fs $fsarg
692     $verbose "  remove snapshot"
693
694     ## If we failed to copy, then give up.
695     case $rc_rsync:$rc_fshash in
696       0:0) ;;
697       0:*) return $rc_fshash ;;
698       *) return $rc_rsync ;;
699     esac
700
701     ## Get a matching map of the files received.
702     maybe mkdir -m750 -p $STOREDIR/tmp/
703     localmap=$STOREDIR/tmp/fshash.$host.$fs.$date
704     case $dryrun in
705       t) $verbose "     local fshash" ;;
706       nil) $verbose -n "        local fshash..." ;;
707     esac
708     run "local fshash $host:$fs" local_fshash || return $?
709     case $dryrun in nil) $verbose " done" ;; esac
710
711     ## Compare the two maps.
712     set +e
713     fshash_diff=$STOREDIR/tmp/fshash-diff.$host.$fs.$date
714     run "compare fshash maps for $host:$fs" \
715       run_diff $fshash_diff new.fshash $localmap
716     rc_diff=$?
717     set -e
718     case $rc_diff in
719       0)
720         break
721         ;;
722       1)
723         if [ $attempt -ge $retry ]; then return $rc; fi
724         $verbose "      fshash mismatch; retrying"
725         attempt=$(( $attempt + 1 ))
726         ;;
727       *)
728         return $rc_diff
729         ;;
730     esac
731   done
732
733   ## Glorious success.
734   maybe rm -f $localmap
735   case $fshash_diff in nil) ;; *) maybe rm -f $fshash_diff ;; esac
736   $verbose "    fshash match"
737
738   ## Commit this backup.
739   case $dryrun in
740     nil)
741       runhook precommit $host $fs $date
742       mv new $date
743       mv new.fshash $date.fshash
744       insert_index $host $fs $date $VOLUME
745       runhook commit $host $fs $date
746       mkdir hack
747       ln -s $date hack/last
748       mv hack/last .
749       rmdir hack
750       ;;
751   esac
752   $verbose "    commit"
753
754   ## Expire old backups.
755   case "${expire_policy+t},${default_policy+t}" in
756     ,t) expire_policy=$default_policy ;;
757   esac
758   case "${expire_policy+t},$dryrun" in
759     t,nil) run "expiry for $host:$fs" expire_backups ;;
760     t,t) expire_backups ;;
761   esac
762   clear_policy=t
763
764   ## Report success.
765   case $dryrun in
766     t) log "END BACKUP of $host:$fs" ;;
767     nil) log "SUCCESSFUL BACKUP of $host:$fs" ;;
768   esac
769 }
770
771 run_backup_cmd () {
772   fs=$1 date=$2 cmd=$3; shift 3
773   ## try_backup FS DATE COMMAND ARGS ...
774   ##
775   ## Run COMMAND ARGS to back up filesystem FS on the current host,
776   ## maintaining a log, and checking whether it worked.  The caller has
777   ## usually worked out the DATE in order to set up the filesystem, and we
778   ## need it to name the log file properly.
779
780   ## Find a name for the log file.  In unusual circumstances, we may have
781   ## deleted old logs from today, so just checking for an unused sequence
782   ## number is insufficient.  Instead, check all of the logfiles for today,
783   ## and use a sequence number that's larger than any of them.
784   case $dryrun in
785     t)
786       log=/dev/null
787       ;;
788     nil)
789       seq=1
790       for i in "$logdir/$host/$fs.$date#"*; do
791         tail=${i##*#}
792         case "$tail" in [!1-9]* | *[!0-9]*) continue ;; esac
793         if [ -f "$i" -a $tail -ge $seq ]; then seq=$(( tail + 1 )); fi
794       done
795       log="$logdir/$host/$fs.$date#$seq"
796       ;;
797   esac
798
799   ## Run the backup command.
800   case $dryrun in nil) mkdir -p $logdir/$host ;; esac
801   if ! "$cmd" "$@" 9>$log 1>&9; then
802     echo >&2
803     echo >&2 "$quis: backup of $host:$fs FAILED!"
804     bkprc=1
805   fi
806
807   ## Clear away any old logfiles.
808   remove_old_logfiles "$logdir/$host/$fs"
809 }
810
811 backup () {
812   ## backup FS[:ARG] ...
813   ##
814   ## Back up the filesystems on the currently selected host using the
815   ## currently selected snapshot type.
816
817   ## Make sure that there's a store volume.  We must do this here rather than
818   ## in the main body of the script, since the configuration file needs a
819   ## chance to override STOREDIR.
820   if ! [ -r $STOREDIR/.rsync-backup-store ]; then
821     echo >&2 "$quis: no backup volume mounted"
822     exit 15
823   fi
824
825   ## Read the volume name if we don't have one already.  Again, this allows
826   ## the configuration file to provide a volume name.
827   case "${VOLUME+t}${VOLUME-nil}" in
828     nil) VOLUME=$(cat $METADIR/volume) ;;
829   esac
830
831   ## Back up each requested file system in turn.
832   for fs in "$@"; do
833
834     ## Parse the argument.
835     case $fs in
836       *:*) fsarg=${fs#*:} fs=${fs%%:*} ;;
837       *) fsarg="" ;;
838     esac
839     $verbose "  filesystem $fs"
840
841     ## Move to the store directory and set up somewhere to put this backup.
842     cd $STOREDIR
843     case $dryrun in
844       nil)
845         if [ ! -d $host ]; then
846           mkdir -m755 $host
847           chown root:root $host
848         fi
849         if [ ! -d $host/$fs ]; then
850           mkdir -m750 $host/$fs
851           chown root:backup $host/$fs
852         fi
853         ;;
854     esac
855     cd $host/$fs
856
857     ## Find out if we've already copied this filesystem today.
858     date=$(date +%Y-%m-%d)
859     if [ $dryrun = nil ] && [ -d $date ]; then
860       $verbose "        already dumped"
861       continue
862     fi
863
864     ## Do the backup of this filesystem.
865     run_backup_cmd $fs $date do_backup $date $fs $fsarg
866   done
867 }
868
869 ###--------------------------------------------------------------------------
870 ### Configuration functions.
871
872 defhook start
873 defhook end
874
875 done_first_host_p=nil
876
877 host () {
878   host=$1
879   like= userat=
880   case $done_first_host_p in
881     nil) runhook start; done_first_host_p=t ;;
882   esac
883   case "${expire_policy+t},${default_policy+t}" in
884     t,) default_policy=$expire_policy ;;
885   esac
886   unset expire_policy
887   $verbose "host $host"
888 }
889
890 snaptype () { snap=$1; shift; snapargs="$*"; retry=1; }
891 rsyncargs () { rsyncargs="$*"; }
892 like () { like="$*"; }
893 retry () { retry="$*"; }
894 user () { userat="$*@"; }
895
896 retain () {
897   case $clear_policy in t) unset expire_policy; clear_policy=nil ;; esac
898   expire_policy="${expire_policy+$expire_policy
899 }$*"
900 }
901
902 ###--------------------------------------------------------------------------
903 ### Read the configuration and we're done.
904
905 usage () {
906   echo "usage: $quis [-nv] [-c CONF]"
907 }
908
909 version () {
910   echo "$quis version $VERSION"
911 }
912
913 whine () { echo >&8 "$@"; }
914
915 while getopts "hVvc:n" opt; do
916   case "$opt" in
917     h) usage; exit 0 ;;
918     V) version; config; exit 0 ;;
919     v) verbose=whine ;;
920     c) conf=$OPTARG ;;
921     n) dryrun=t ;;
922     *) exit 1 ;;
923   esac
924 done
925 shift $((OPTIND - 1))
926 case $# in 0) ;; *) usage >&2; exit 1 ;; esac
927 exec 8>&1
928
929 . "$conf"
930
931 runhook end $bkprc
932 case "$bkprc" in
933   0) $verbose "All backups successful" ;;
934   *) $verbose "Backups FAILED" ;;
935 esac
936
937 ###----- That's all, folks --------------------------------------------------
938
939 exit $bkprc